import ddf.minim.spi.*;
import ddf.minim.signals.*;
import ddf.minim.*;
import ddf.minim.analysis.*;
import ddf.minim.ugens.*;
import ddf.minim.effects.*;

import processing.serial.*;

Minim minim;
AudioPlayer sou;   //variable name;
AudioPlayer mus;    //background music variable name

int end = 10;
Serial myPort;          //The serial port
//String whichPos;             //Values of x, y user position sent from arduino
 int whichPos=0;
float xPos;        //x position
float yPos;        //y position


PShape square;          // Square tracking the user's movement

float x = 0;            //x-coordinate of square
float y = 0;            //y-coordinate of square
float val;

void setup() {
  size(500, 500, P2D);
  noStroke();
  
  square = createShape(RECT, 0, 0, 50, 50);
  square.setFill(color(225, 0, 0));
  square.setStroke(false);
  
  myPort = new Serial(this, Serial.list()[7], 38400);  
  myPort.bufferUntil('\n');
  
  drawRect();
  minim= new Minim(this);
  sou = minim.loadFile("thump.mp3");
  
}

void draw(){
  
  background(0); 

  fill (225, 225, 0);
  ellipse(450, 450, 50, 50);
  
  fill(225, 0, 225);
  rect (0, 100, 300, 100);
  rect (400, 100, 100, 100);
  rect (200, 300, 300, 100);
  rect (0, 300, 100, 200);
  rect (100, 500, 400, 100);
   if (y>=400&& x>=400) {
      fill(225);
      textSize(20);
      text("Congratulations, you've completed the maze!", 0, 350);
   }
   
     //manual movement of rectangle with keyboard
//  if (keyPressed) {
//    if ( keyCode == RIGHT) {
//      x = x+2;
//    }
//    if (keyCode == LEFT) {
//      x = x-2;
//    }
//    if (keyCode ==DOWN) {
//      y= y+2;
//    }
//    if (keyCode == UP) {
//      y = y-2;
//    }
    updateRect();
 }
    
void serialEvent (Serial myPort) {
  float val = float(myPort.readStringUntil(end)); 
    
    if(val==1) {
      whichPos = 1; 
       
    }
    else if(val ==2) {
      whichPos = 2;
    }
    else {
      if(whichPos==1) {
        xPos = val;
        
      }
      else if (whichPos==2) {
        yPos = val;
      }
    }

  } 


void updateRect() {
  
  x=xPos;
  //x bounds of the application
  if (x >= 450) {
      x = 450;
      sou.play();
    }
    if ( x <= 0) {
      x = 0;
      sou.play();
      
    }
    
  //vertical walls
  if(x>=250 && x<310 && y>=100 && y<=200) {
    x= 300;
    sou.play();
  } 
  else if(x>=350 && y>=100 && y<200) {
    x= 350;
    sou.play();
  } 
  else if(x>=50 && x<110 && y>=300 && y<=500) {
    x= 100;
    sou.play();
  } 
  else  if(x>=150 && y>=300 && y<400) {
    x= 150;
    sou.play();
  } 
  
  y=yPos;
  //y bounds of the application
    if (y <= 0) {
      y = 0;
      
      sou.play();
      
    }
    if (y >= 450) {
      y = 450;
    
      sou.play();
    }
  
  //horizontal walls
  if ( x>=0 && x <=300 && y >=50 && y<=100 ) {
    y=50;
    sou.close();
    sou.play();
  } 
  else if ( x>=0 && x <=300 && y> 150 && y<= 200) {
    y=200;
    
    sou.play();
  } else if ( x >= 350 && x <= 450 && y>=50 && y<=100) {
    y=50;
    
    sou.play();
  } else if ( x>= 350 && x <= 450 && y>150 && y <=200) {
    y=200;
    sou.play();
  } else if ( x>= 0 && x <= 100 && y>=250 && y<=300) {
    y=250;
   sou.play(); 
  } else if (x >=200 && x<=450 && y>=250 && y<=300) {
    y=250;
    sou.play();
  } else if (x >=200 && x<=450 && y<=400 && y>=350) {
    y=400;
    sou.play();
  } 

  drawRect();  
}

void drawRect() {
  shape(square, x, y);
  println(xPos);
  println(yPos);
}

 
 
 
 
 
  
  
  

